"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SplTokenCollective = void 0;
const anchor = __importStar(require("@project-serum/anchor"));
const common_1 = require("@project-serum/common");
const spl_token_1 = require("@solana/spl-token");
const web3_js_1 = require("@solana/web3.js");
const spl_token_bonding_1 = require("@strata-foundation/spl-token-bonding");
const spl_utils_1 = require("@strata-foundation/spl-utils");
const bn_js_1 = __importDefault(require("bn.js"));
__exportStar(require("./generated/spl-token-collective"), exports);
(0, spl_utils_1.extendBorsh)();
function undefinedToNull(obj) {
    if (typeof obj === "undefined") {
        return null;
    }
    return obj;
}
function toIdlTokenMetadataSettings(settings) {
    return {
        symbol: undefinedToNull(settings === null || settings === void 0 ? void 0 : settings.symbol),
        uri: undefinedToNull(settings === null || settings === void 0 ? void 0 : settings.uri),
        nameIsNameServiceName: !!(settings === null || settings === void 0 ? void 0 : settings.nameIsNameServiceName),
    };
}
function toIdlRoyaltySettings(settings) {
    return {
        ownedByName: !!(settings === null || settings === void 0 ? void 0 : settings.ownedByName),
        address: undefinedToNull(settings === null || settings === void 0 ? void 0 : settings.address),
    };
}
function toIdlTokenBondingSettings(settings) {
    return {
        curve: undefinedToNull(settings === null || settings === void 0 ? void 0 : settings.curve),
        minSellBaseRoyaltyPercentage: undefinedToNull((0, spl_utils_1.percent)(settings === null || settings === void 0 ? void 0 : settings.minSellBaseRoyaltyPercentage)),
        minSellTargetRoyaltyPercentage: undefinedToNull((0, spl_utils_1.percent)(settings === null || settings === void 0 ? void 0 : settings.minSellTargetRoyaltyPercentage)),
        maxSellBaseRoyaltyPercentage: undefinedToNull((0, spl_utils_1.percent)(settings === null || settings === void 0 ? void 0 : settings.maxSellBaseRoyaltyPercentage)),
        maxSellTargetRoyaltyPercentage: undefinedToNull((0, spl_utils_1.percent)(settings === null || settings === void 0 ? void 0 : settings.maxSellTargetRoyaltyPercentage)),
        minBuyBaseRoyaltyPercentage: undefinedToNull((0, spl_utils_1.percent)(settings === null || settings === void 0 ? void 0 : settings.minBuyBaseRoyaltyPercentage)),
        minBuyTargetRoyaltyPercentage: undefinedToNull((0, spl_utils_1.percent)(settings === null || settings === void 0 ? void 0 : settings.minBuyTargetRoyaltyPercentage)),
        maxBuyBaseRoyaltyPercentage: undefinedToNull((0, spl_utils_1.percent)(settings === null || settings === void 0 ? void 0 : settings.maxBuyBaseRoyaltyPercentage)),
        maxBuyTargetRoyaltyPercentage: undefinedToNull((0, spl_utils_1.percent)(settings === null || settings === void 0 ? void 0 : settings.maxBuyTargetRoyaltyPercentage)),
        targetMintDecimals: undefinedToNull(settings === null || settings === void 0 ? void 0 : settings.targetMintDecimals),
        // @ts-ignore
        buyBaseRoyalties: toIdlRoyaltySettings(settings === null || settings === void 0 ? void 0 : settings.buyBaseRoyalties),
        // @ts-ignore
        sellBaseRoyalties: toIdlRoyaltySettings(settings === null || settings === void 0 ? void 0 : settings.sellBaseRoyalties),
        // @ts-ignore
        buyTargetRoyalties: toIdlRoyaltySettings(settings === null || settings === void 0 ? void 0 : settings.buyTargetRoyalties),
        // @ts-ignore
        sellTargetRoyalties: toIdlRoyaltySettings(settings === null || settings === void 0 ? void 0 : settings.sellTargetRoyalties),
        minPurchaseCap: undefinedToNull(settings === null || settings === void 0 ? void 0 : settings.minPurchaseCap),
        maxPurchaseCap: undefinedToNull(settings === null || settings === void 0 ? void 0 : settings.maxPurchaseCap),
        minMintCap: undefinedToNull(settings === null || settings === void 0 ? void 0 : settings.minMintCap),
        maxMintCap: undefinedToNull(settings === null || settings === void 0 ? void 0 : settings.maxMintCap),
    };
}
function toIdlConfig(config) {
    return {
        isOpen: config.isOpen,
        // @ts-ignore
        unclaimedTokenBondingSettings: toIdlTokenBondingSettings(config.unclaimedTokenBondingSettings),
        // @ts-ignore
        claimedTokenBondingSettings: toIdlTokenBondingSettings(config.claimedTokenBondingSettings),
        // @ts-ignore
        unclaimedTokenMetadataSettings: toIdlTokenMetadataSettings(config.unclaimedTokenMetadataSettings),
    };
}
class SplTokenCollective extends spl_utils_1.AnchorSdk {
    constructor(opts) {
        super(opts);
        /**
         * Account decoder to a unified TokenRef interface
         *
         * @param pubkey
         * @param account
         * @returns
         */
        this.tokenRefDecoder = (pubkey, account) => {
            const coded = this.program.coder.accounts.decode("TokenRefV0", account.data);
            return Object.assign(Object.assign({}, coded), { publicKey: pubkey });
        };
        /**
         * Account decoder to a unified Collective interface
         *
         * @param pubkey
         * @param account
         * @returns
         */
        this.collectiveDecoder = (pubkey, account) => {
            const coded = this.program.coder.accounts.decode("CollectiveV0", account.data);
            return Object.assign(Object.assign({}, coded), { publicKey: pubkey });
        };
        this.splTokenBondingProgram = opts.splTokenBondingProgram;
        this.splTokenMetadata = opts.splTokenMetadata;
    }
    static init(provider, splCollectiveProgramId = SplTokenCollective.ID, splTokenBondingProgramId = spl_token_bonding_1.SplTokenBonding.ID) {
        return __awaiter(this, void 0, void 0, function* () {
            const SplCollectiveIDLJson = yield anchor.Program.fetchIdl(splCollectiveProgramId, provider);
            const splCollective = new anchor.Program(SplCollectiveIDLJson, splCollectiveProgramId, provider);
            const splTokenBondingProgram = yield spl_token_bonding_1.SplTokenBonding.init(provider, splTokenBondingProgramId);
            const splTokenMetadata = yield spl_utils_1.SplTokenMetadata.init(provider);
            return new this({
                provider,
                program: splCollective,
                splTokenBondingProgram,
                splTokenMetadata,
            });
        });
    }
    getCollective(collectiveKey) {
        return this.getAccount(collectiveKey, this.collectiveDecoder);
    }
    getTokenRef(tokenRefKey) {
        return this.getAccount(tokenRefKey, this.tokenRefDecoder);
    }
    /**
     * Instructions to create a Collective
     *
     * @param param0
     * @returns
     */
    createCollectiveInstructions({ payer = this.wallet.publicKey, mint, authority, mintAuthority, config, bonding, metadata, }) {
        return __awaiter(this, void 0, void 0, function* () {
            const programId = this.programId;
            const instructions = [];
            const signers = [];
            let metadataUri = metadata === null || metadata === void 0 ? void 0 : metadata.uri;
            let metadataAdded = false;
            const addMetadata = () => __awaiter(this, void 0, void 0, function* () {
                if (metadata && !metadataAdded) {
                    const { instructions: metadataInstructions, signers: metadataSigners } = yield this.splTokenMetadata.createMetadataInstructions({
                        mint: mint,
                        authority: mintAuthority,
                        data: new spl_utils_1.Data({
                            name: metadata.name,
                            symbol: metadata.symbol,
                            uri: metadata.uri,
                            creators: null,
                            sellerFeeBasisPoints: 0,
                        }),
                    });
                    instructions.push(...metadataInstructions);
                    signers.push(...metadataSigners);
                }
                metadataAdded = true;
            });
            if (!mint) {
                const targetMintKeypair = (bonding === null || bonding === void 0 ? void 0 : bonding.targetMintKeypair) || anchor.web3.Keypair.generate();
                signers.push(targetMintKeypair);
                mint = targetMintKeypair.publicKey;
                instructions.push(...(yield (0, common_1.createMintInstructions)(this.provider, payer, mint, (bonding === null || bonding === void 0 ? void 0 : bonding.targetMintDecimals) || 9)));
                mintAuthority = payer;
                yield addMetadata();
            }
            if (!mintAuthority) {
                const mintAcct = yield this.provider.connection.getAccountInfo(mint);
                const data = Buffer.from(mintAcct.data);
                const mintInfo = spl_token_1.MintLayout.decode(data);
                if (mintInfo.mintAuthorityOption === 0) {
                    throw new Error("Must have mint authority to create a collective");
                }
                else {
                    mintAuthority = new web3_js_1.PublicKey(mintInfo.mintAuthority);
                }
                yield addMetadata();
            }
            const [collective, collectiveBump] = yield web3_js_1.PublicKey.findProgramAddress([Buffer.from("collective", "utf-8"), mint.toBuffer()], programId);
            instructions.push(yield this.instruction.initializeCollectiveV0(
            // @ts-ignore
            {
                authority: authority ? authority : null,
                bumpSeed: collectiveBump,
                config: toIdlConfig(config),
            }, {
                accounts: {
                    collective,
                    mint: mint,
                    mintAuthority: mintAuthority,
                    payer,
                    systemProgram: web3_js_1.SystemProgram.programId,
                    rent: web3_js_1.SYSVAR_RENT_PUBKEY,
                },
            }));
            const instructions2 = [];
            const signers2 = [];
            let tokenBonding;
            if (bonding) {
                // Set back to token bonding's authority
                const [targetMintAuthority] = yield web3_js_1.PublicKey.findProgramAddress([Buffer.from("target-authority", "utf-8"), mint.toBuffer()], this.splTokenBondingProgram.programId);
                instructions2.push(spl_token_1.Token.createSetAuthorityInstruction(spl_token_1.TOKEN_PROGRAM_ID, mint, targetMintAuthority, "MintTokens", mintAuthority, []));
                mintAuthority = targetMintAuthority;
                var { instructions: tokenBondingInstructions, signers: tokenBondingSigners, output: { tokenBonding: outputTokenBonding }, } = yield this.splTokenBondingProgram.createTokenBondingInstructions(Object.assign(Object.assign({}, bonding), { targetMint: mint }));
                tokenBonding = outputTokenBonding;
                instructions2.push(...tokenBondingInstructions);
                signers2.push(...tokenBondingSigners);
            }
            return {
                output: { collective, tokenBonding },
                instructions: [instructions, instructions2],
                signers: [signers, signers2],
            };
        });
    }
    /**
     * Run {@link createCollectiveInstructions}
     * @param args
     * @returns
     */
    createCollective(args) {
        return this.executeBig(this.createCollectiveInstructions(args), args.payer);
    }
    /**
     * Instructions to claim a social token
     *
     * @param param0
     * @returns
     */
    claimSocialTokenInstructions({ payer = this.wallet.publicKey, owner = this.wallet.publicKey, tokenRef, tokenName, symbol, buyBaseRoyalties, buyTargetRoyalties, sellBaseRoyalties, sellTargetRoyalties, ignoreMissingName, isPrimary = true, }) {
        return __awaiter(this, void 0, void 0, function* () {
            const tokenRefAcct = (yield this.getTokenRef(tokenRef));
            const tokenBondingAcct = (yield this.splTokenBondingProgram.getTokenBonding(tokenRefAcct.tokenBonding));
            const name = tokenRefAcct.name;
            const instructions = [];
            if (!ignoreMissingName &&
                !(yield this.splTokenBondingProgram.accountExists(name))) {
                throw new Error("Name account does not exist");
            }
            const defaultBaseRoyalties = yield spl_token_1.Token.getAssociatedTokenAddress(spl_token_1.ASSOCIATED_TOKEN_PROGRAM_ID, spl_token_1.TOKEN_PROGRAM_ID, tokenBondingAcct.baseMint, owner, true);
            const defaultTargetRoyalties = yield spl_token_1.Token.getAssociatedTokenAddress(spl_token_1.ASSOCIATED_TOKEN_PROGRAM_ID, spl_token_1.TOKEN_PROGRAM_ID, tokenBondingAcct.targetMint, owner, true);
            if ((!buyTargetRoyalties || !sellTargetRoyalties) &&
                !(yield this.splTokenBondingProgram.accountExists(defaultTargetRoyalties))) {
                console.log(`Creating target royalties ${defaultTargetRoyalties}...`);
                instructions.push(spl_token_1.Token.createAssociatedTokenAccountInstruction(spl_token_1.ASSOCIATED_TOKEN_PROGRAM_ID, spl_token_1.TOKEN_PROGRAM_ID, tokenBondingAcct.targetMint, defaultTargetRoyalties, owner, payer));
            }
            if ((!buyBaseRoyalties || !sellBaseRoyalties) &&
                !(yield this.splTokenBondingProgram.accountExists(defaultBaseRoyalties))) {
                console.log(`Creating base royalties ${defaultBaseRoyalties}...`);
                instructions.push(spl_token_1.Token.createAssociatedTokenAccountInstruction(spl_token_1.ASSOCIATED_TOKEN_PROGRAM_ID, spl_token_1.TOKEN_PROGRAM_ID, tokenBondingAcct.baseMint, defaultBaseRoyalties, owner, payer));
            }
            if (!buyBaseRoyalties) {
                buyBaseRoyalties = defaultBaseRoyalties;
            }
            if (!sellBaseRoyalties) {
                sellBaseRoyalties = defaultBaseRoyalties;
            }
            if (!buyTargetRoyalties) {
                buyTargetRoyalties = defaultTargetRoyalties;
            }
            if (!sellTargetRoyalties) {
                sellTargetRoyalties = defaultTargetRoyalties;
            }
            const [reverseTokenRef] = yield SplTokenCollective.reverseTokenRefKey(tokenBondingAcct.targetMint);
            const tokenBondingAuthority = yield web3_js_1.PublicKey.createProgramAddress([
                Buffer.from("token-bonding-authority", "utf-8"),
                reverseTokenRef.toBuffer(),
                new bn_js_1.default(tokenRefAcct.tokenBondingAuthorityBumpSeed).toBuffer(),
            ], this.programId);
            const [newTokenRef, tokenRefBumpSeed] = yield web3_js_1.PublicKey.findProgramAddress(SplTokenCollective.tokenRefSeeds({
                collective: tokenRefAcct.collective,
                owner,
            }), this.programId);
            const metadataUpdateAuthority = yield web3_js_1.PublicKey.createProgramAddress([
                Buffer.from("token-metadata-authority", "utf-8"),
                reverseTokenRef.toBuffer(),
                new bn_js_1.default(tokenRefAcct.tokenMetadataUpdateAuthorityBumpSeed).toBuffer(),
            ], this.programId);
            const [royaltiesOwner] = yield web3_js_1.PublicKey.findProgramAddress([
                Buffer.from("standin-royalties-owner", "utf-8"),
                reverseTokenRef.toBuffer(),
            ], this.programId);
            instructions.push(yield this.instruction.claimSocialTokenV0({
                tokenRefBumpSeed,
                isPrimary,
            }, {
                accounts: {
                    payer,
                    collective: tokenRefAcct.collective,
                    tokenRef: tokenRef,
                    newTokenRef,
                    reverseTokenRef,
                    tokenBonding: tokenRefAcct.tokenBonding,
                    tokenMetadata: tokenRefAcct.tokenMetadata,
                    tokenBondingAuthority,
                    metadataUpdateAuthority,
                    name,
                    owner,
                    baseMint: tokenBondingAcct.baseMint,
                    targetMint: tokenBondingAcct.targetMint,
                    buyBaseRoyalties: tokenBondingAcct.buyBaseRoyalties,
                    buyTargetRoyalties: tokenBondingAcct.buyTargetRoyalties,
                    sellBaseRoyalties: tokenBondingAcct.sellBaseRoyalties,
                    sellTargetRoyalties: tokenBondingAcct.sellTargetRoyalties,
                    newBuyBaseRoyalties: buyBaseRoyalties,
                    newBuyTargetRoyalties: buyTargetRoyalties,
                    newSellBaseRoyalties: sellBaseRoyalties,
                    newSellTargetRoyalties: sellTargetRoyalties,
                    royaltiesOwner,
                    tokenProgram: spl_token_1.TOKEN_PROGRAM_ID,
                    tokenBondingProgram: this.splTokenBondingProgram.programId,
                    tokenMetadataProgram: spl_utils_1.METADATA_PROGRAM_ID,
                    systemProgram: web3_js_1.SystemProgram.programId,
                    rent: web3_js_1.SYSVAR_RENT_PUBKEY,
                },
            }));
            if (symbol) {
                const tokenMetadataRaw = yield this.provider.connection.getAccountInfo(tokenRefAcct.tokenMetadata);
                const tokenMetadata = (0, spl_utils_1.decodeMetadata)(tokenMetadataRaw.data);
                (0, spl_utils_1.updateMetadata)(new spl_utils_1.Data({
                    name: tokenName || tokenMetadata.data.name,
                    symbol: symbol || tokenMetadata.data.symbol,
                    uri: tokenMetadata.data.uri,
                    sellerFeeBasisPoints: 0,
                    creators: null,
                }), undefined, undefined, tokenBondingAcct.targetMint.toBase58(), owner.toBase58(), instructions, tokenRefAcct.tokenMetadata.toBase58());
            }
            if (isPrimary) {
                const { instructions: setAsPrimaryInstrs } = yield this.setAsPrimaryInstructions({
                    tokenRef,
                    payer,
                    owner,
                });
                instructions.push(...setAsPrimaryInstrs);
            }
            return {
                signers: [],
                instructions,
                output: null,
            };
        });
    }
    /**
     * Run {@link claimSocialTokenInstructions}
     * @param args
     */
    claimSocialToken(args) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.execute(this.claimSocialTokenInstructions(args));
        });
    }
    /**
     * Get the seeds for the PDA of a token ref given the various parameters.
     *
     * @param param0
     * @returns
     */
    static tokenRefSeeds({ owner, name, collective, isPrimary, }) {
        const str = Buffer.from("token-ref", "utf-8");
        if ((isPrimary || !collective) && !name) {
            if (!owner) {
                throw new Error("Owner is required for a primary token refs");
            }
            return [str, owner.toBuffer()];
        }
        else {
            if (!collective) {
                throw new Error("Collective is required for non-primary token refs");
            }
            return [str, (name || owner).toBuffer(), collective.toBuffer()];
        }
    }
    static tokenRefKey(args, programId = SplTokenCollective.ID) {
        return __awaiter(this, void 0, void 0, function* () {
            return web3_js_1.PublicKey.findProgramAddress(this.tokenRefSeeds(args), programId);
        });
    }
    static reverseTokenRefKey(mint, programId = SplTokenCollective.ID) {
        return __awaiter(this, void 0, void 0, function* () {
            return web3_js_1.PublicKey.findProgramAddress([Buffer.from("reverse-token-ref", "utf-8"), mint.toBuffer()], programId);
        });
    }
    /**
     * Get instructions to set this tokenRef as our primary token ref (lookups to "token-ref", owner pda find this tokenRef)
     *
     * @param param0
     * @returns
     */
    setAsPrimaryInstructions({ payer = this.wallet.publicKey, tokenRef, owner, }) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!owner) {
                // @ts-ignore
                owner = (yield this.getTokenRef(tokenRef)).owner;
            }
            const [primaryTokenRef, primaryTokenRefBumpSeed] = yield web3_js_1.PublicKey.findProgramAddress(SplTokenCollective.tokenRefSeeds({ isPrimary: true, owner }), this.programId);
            return {
                signers: [],
                instructions: [
                    yield this.instruction.setAsPrimaryV0({
                        bumpSeed: primaryTokenRefBumpSeed,
                    }, {
                        accounts: {
                            payer,
                            owner: owner,
                            tokenRef,
                            primaryTokenRef,
                            systemProgram: web3_js_1.SystemProgram.programId,
                            rent: web3_js_1.SYSVAR_RENT_PUBKEY,
                        },
                    }),
                ],
                output: {
                    primaryTokenRef,
                },
            };
        });
    }
    /**
     * Run {@link setAsPrimaryInstructions}
     * @param args
     */
    setAsPrimary(args) {
        return this.execute(this.setAsPrimaryInstructions(args));
    }
    /**
     * Get instructions to update this collective
     *
     * @param param0
     * @returns
     */
    updateCollectiveInstructions({ collective, authority, config, }) {
        return __awaiter(this, void 0, void 0, function* () {
            if (typeof authority == "undefined") {
                // @ts-ignore
                authority = (yield this.getCollective(collective)).authority;
            }
            return {
                signers: [],
                instructions: [
                    yield this.instruction.updateCollectiveV0(
                    // @ts-ignore
                    {
                        config: toIdlConfig(config),
                        authority,
                    }, {
                        accounts: {
                            collective,
                            authority,
                        },
                    }),
                ],
                output: null,
            };
        });
    }
    /**
     * Run {@link updateCollectiveInstructions}
     * @param args
     */
    updateCollective(args) {
        return this.execute(this.updateCollectiveInstructions(args));
    }
    /**
     * Instructions to create everything around a social token... metadata, bonding curves, etc.
     *
     * @param param0
     * @returns
     */
    createSocialTokenInstructions({ ignoreIfExists = false, payer = this.wallet.publicKey, collective = SplTokenCollective.OPEN_COLLECTIVE_ID, name, owner, targetMintKeypair = anchor.web3.Keypair.generate(), metadata, nameClass, nameParent, tokenBondingParams, isPrimary = name ? false : true, }) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
        return __awaiter(this, void 0, void 0, function* () {
            let metadataUri = metadata === null || metadata === void 0 ? void 0 : metadata.uri;
            if (!owner && !name) {
                owner = this.wallet.publicKey;
            }
            const curve = tokenBondingParams.curve;
            const programId = this.programId;
            const provider = this.provider;
            const instructions1 = [];
            const signers1 = [];
            const collectiveAcct = (yield this.getCollective(collective));
            const config = collectiveAcct.config;
            // Token refs
            const [tokenRef, tokenRefBumpSeed] = yield web3_js_1.PublicKey.findProgramAddress(SplTokenCollective.tokenRefSeeds({ collective, owner, name }), programId);
            // create mint with payer as auth
            console.log(`Creating social token mint ${targetMintKeypair.publicKey.toBase58()}`);
            signers1.push(targetMintKeypair);
            const targetMint = targetMintKeypair.publicKey;
            instructions1.push(...(yield (0, common_1.createMintInstructions)(provider, payer, targetMint, tokenBondingParams.targetMintDecimals ||
                (
                // @ts-ignore
                (_a = config.unclaimedTokenBondingSettings) === null || _a === void 0 ? void 0 : _a.targetMintDecimals) ||
                9)));
            const [reverseTokenRef, reverseTokenRefBumpSeed] = yield SplTokenCollective.reverseTokenRefKey(targetMint);
            console.log("tokenRef", tokenRef.toBase58());
            console.log("reverse", reverseTokenRef.toBase58());
            const existing = yield this.account.tokenRefV0.fetchNullable(tokenRef);
            if (existing) {
                if (ignoreIfExists) {
                    return {
                        instructions: [],
                        signers: [],
                        output: {
                            mint: existing.mint,
                            tokenRef,
                            reverseTokenRef,
                            tokenBonding: existing.tokenBonding,
                        },
                    };
                }
                throw new Error("Social token already exists for this wallet or name");
            }
            // create metadata with payer as temporary authority
            console.log("Creating social token metadata...");
            const [tokenMetadataUpdateAuthority, tokenMetadataUpdateAuthorityBumpSeed] = yield web3_js_1.PublicKey.findProgramAddress([
                Buffer.from("token-metadata-authority", "utf-8"),
                reverseTokenRef.toBuffer(),
            ], programId);
            // @ts-ignore
            let uri = metadataUri || ((_b = config.unclaimedTokenMetadataSettings) === null || _b === void 0 ? void 0 : _b.uri);
            if (!uri) {
                throw new Error("Must pass metadata.uri or it must be defined on the collective config");
            }
            const { instructions: metadataInstructions, signers: metadataSigners, output: { metadata: tokenMetadata }, } = yield this.splTokenMetadata.createMetadataInstructions({
                mint: targetMint,
                authority: owner ? owner : tokenMetadataUpdateAuthority,
                data: new spl_utils_1.Data({
                    name: metadata.name,
                    symbol: metadata.symbol,
                    uri,
                    creators: null,
                    sellerFeeBasisPoints: 0,
                }),
            });
            instructions1.push(...metadataInstructions);
            signers1.push(...metadataSigners);
            // Set mint authority to token bondings authority
            const [targetMintAuthority, targetMintAuthorityBumpSeed] = yield web3_js_1.PublicKey.findProgramAddress([Buffer.from("target-authority", "utf-8"), targetMint.toBuffer()], this.splTokenBondingProgram.programId);
            instructions1.push(spl_token_1.Token.createSetAuthorityInstruction(spl_token_1.TOKEN_PROGRAM_ID, targetMint, targetMintAuthority, "MintTokens", payer, []));
            const [tokenBondingAuthority, tokenBondingAuthorityBumpSeed] = yield web3_js_1.PublicKey.findProgramAddress([
                Buffer.from("token-bonding-authority", "utf-8"),
                reverseTokenRef.toBuffer(),
            ], programId);
            const [standinRoyaltiesOwner] = yield web3_js_1.PublicKey.findProgramAddress([
                Buffer.from("standin-royalties-owner", "utf-8"),
                reverseTokenRef.toBuffer(),
            ], programId);
            // Create token bonding
            const instructions2 = [];
            const tokenBondingSettings = owner
                ? config.claimedTokenBondingSettings
                : config.unclaimedTokenBondingSettings;
            const signers2 = [];
            const curveToUse = (curve ||
                // @ts-ignore
                (!owner && ((_c = collectiveAcct.config.unclaimedTokenBondingSettings) === null || _c === void 0 ? void 0 : _c.curve)) ||
                // @ts-ignore
                (owner && ((_d = collectiveAcct.config.claimedTokenBondingSettings) === null || _d === void 0 ? void 0 : _d.curve)) ||
                (
                // @ts-ignore
                (_e = collectiveAcct.config.unclaimedTokenBondingSettings) === null || _e === void 0 ? void 0 : _e.curve) ||
                (
                // @ts-ignore
                (_f = collectiveAcct.config.claimedTokenBondingSettings) === null || _f === void 0 ? void 0 : _f.curve));
            if (!curveToUse) {
                throw new Error("No curve provided");
            }
            const { instructions: bondingInstructions, signers: bondingSigners, output: { tokenBonding, buyBaseRoyalties, buyTargetRoyalties, sellBaseRoyalties, sellTargetRoyalties, }, } = yield this.splTokenBondingProgram.createTokenBondingInstructions(Object.assign({ payer, 
                // @ts-ignore
                curve: curveToUse, baseMint: collectiveAcct.mint, targetMint, generalAuthority: tokenBondingAuthority, reserveAuthority: tokenBondingAuthority, curveAuthority: tokenBondingAuthority, 
                // @ts-ignore
                buyBaseRoyaltiesOwner: (tokenBondingSettings === null || tokenBondingSettings === void 0 ? void 0 : tokenBondingSettings.buyBaseRoyalties.ownedByName)
                    ? standinRoyaltiesOwner
                    : undefined, 
                // @ts-ignore
                sellBaseRoyaltiesOwner: (tokenBondingSettings === null || tokenBondingSettings === void 0 ? void 0 : tokenBondingSettings.sellBaseRoyalties.ownedByName)
                    ? standinRoyaltiesOwner
                    : undefined, 
                // @ts-ignore
                buyTargetRoyaltiesOwner: (tokenBondingSettings === null || tokenBondingSettings === void 0 ? void 0 : tokenBondingSettings.buyTargetRoyalties.ownedByName)
                    ? standinRoyaltiesOwner
                    : undefined, 
                // @ts-ignore
                sellTargetRoyaltiesOwner: (tokenBondingSettings === null || tokenBondingSettings === void 0 ? void 0 : tokenBondingSettings.sellTargetRoyalties.ownedByName)
                    ? standinRoyaltiesOwner
                    : undefined, 
                // @ts-ignore
                buyBaseRoyalties: (_g = tokenBondingSettings === null || tokenBondingSettings === void 0 ? void 0 : tokenBondingSettings.buyBaseRoyalties) === null || _g === void 0 ? void 0 : _g.address, 
                // @ts-ignore
                sellBaseRoyalties: (_h = tokenBondingSettings === null || tokenBondingSettings === void 0 ? void 0 : tokenBondingSettings.sellBaseRoyalties) === null || _h === void 0 ? void 0 : _h.address, 
                // @ts-ignore
                buyTargetRoyalties: (_j = tokenBondingSettings === null || tokenBondingSettings === void 0 ? void 0 : tokenBondingSettings.buyTargetRoyalties) === null || _j === void 0 ? void 0 : _j.address, 
                // @ts-ignore
                sellTargetRoyalties: (_k = tokenBondingSettings === null || tokenBondingSettings === void 0 ? void 0 : tokenBondingSettings.sellTargetRoyalties) === null || _k === void 0 ? void 0 : _k.address }, tokenBondingParams));
            instructions2.push(...bondingInstructions);
            signers2.push(...bondingSigners);
            const initializeArgs = {
                collective,
                tokenMetadata: new web3_js_1.PublicKey(tokenMetadata),
                tokenBonding,
                payer,
                baseMint: collectiveAcct.mint,
                targetMint,
                buyBaseRoyalties,
                buyTargetRoyalties,
                sellBaseRoyalties,
                sellTargetRoyalties,
                systemProgram: web3_js_1.SystemProgram.programId,
                rent: web3_js_1.SYSVAR_RENT_PUBKEY,
                clock: web3_js_1.SYSVAR_CLOCK_PUBKEY,
            };
            const args = {
                nameClass: nameClass || null,
                nameParent: nameParent || null,
                collectiveBumpSeed: collectiveAcct.bumpSeed,
                tokenBondingAuthorityBumpSeed,
                tokenRefBumpSeed,
                reverseTokenRefBumpSeed,
                tokenMetadataUpdateAuthorityBumpSeed,
            };
            console.log(args);
            const instructions3 = [];
            const signers3 = [];
            if (owner) {
                instructions3.push(yield this.instruction.initializeOwnedSocialTokenV0(args, {
                    accounts: {
                        initializeArgs,
                        authority: collectiveAcct.authority ||
                            web3_js_1.PublicKey.default,
                        owner,
                        payer,
                        tokenRef,
                        reverseTokenRef,
                        systemProgram: web3_js_1.SystemProgram.programId,
                        rent: web3_js_1.SYSVAR_RENT_PUBKEY,
                    },
                }));
                if (isPrimary) {
                    const { instructions: setAsPrimaryInstrs } = yield this.setAsPrimaryInstructions({
                        tokenRef,
                        payer,
                        owner,
                    });
                    instructions3.push(...setAsPrimaryInstrs);
                }
            }
            else {
                instructions3.push(yield this.instruction.initializeUnclaimedSocialTokenV0(args, {
                    accounts: {
                        initializeArgs,
                        authority: collectiveAcct.authority ||
                            web3_js_1.PublicKey.default,
                        name: name,
                        payer,
                        tokenRef,
                        reverseTokenRef,
                        tokenMetadata,
                        systemProgram: web3_js_1.SystemProgram.programId,
                        rent: web3_js_1.SYSVAR_RENT_PUBKEY,
                    },
                }));
            }
            return {
                output: {
                    mint: targetMintKeypair.publicKey,
                    tokenRef,
                    reverseTokenRef,
                    tokenBonding,
                },
                instructions: [instructions1, instructions2, instructions3],
                signers: [signers1, signers2, signers3],
            };
        });
    }
    /**
     * Run {@link createSocialTokenInstructions}
     * @param args
     * @returns
     */
    createSocialToken(args) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.executeBig(this.createSocialTokenInstructions(args), args.payer);
        });
    }
    getUserTokensWithMeta(tokenAccounts) {
        return Promise.all((tokenAccounts || []).map(({ pubkey, info }) => __awaiter(this, void 0, void 0, function* () {
            const metadataKey = yield (0, spl_utils_1.getMetadata)(info.mint.toBase58());
            const [reverseTokenRefKey] = yield SplTokenCollective.reverseTokenRefKey(info.mint);
            const account = yield this.provider.connection.getAccountInfo(reverseTokenRefKey);
            const tokenRef = account && this.tokenRefDecoder(reverseTokenRefKey, account);
            return Object.assign(Object.assign({}, (yield this.splTokenMetadata.getTokenMetadata(new web3_js_1.PublicKey(metadataKey)))), { tokenRef: tokenRef || undefined, publicKey: pubkey, account: info });
        })));
    }
}
exports.SplTokenCollective = SplTokenCollective;
SplTokenCollective.ID = new web3_js_1.PublicKey("TCo1sP6RwuCuyHPHjxgzcrq4dX4BKf9oRQ3aJMcdFry");
SplTokenCollective.OPEN_COLLECTIVE_ID = new web3_js_1.PublicKey("Dqe1nFRkTGvimkimmWnxekBa97rCnTetEekCrGFVPVhd");
SplTokenCollective.OPEN_COLLECTIVE_BONDING_ID = new web3_js_1.PublicKey("8P533JdGaPv1h7JnVQT5RgbDvgg1vFyNUtg4P6z3etxF");
SplTokenCollective.OPEN_COLLECTIVE_MINT_ID = new web3_js_1.PublicKey("openQPYpSNGhxMBPeMdftdpJzEFksd94giFKuhH7A5a");
//# sourceMappingURL=index.js.map